gcfactorys = {};

--needs gcfactorys
--lineType 2/gcfactorys
function gcfactorys:load(gcfactoryName)
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moGC_Factorys.values.factorys ~= nil and moGC_Factorys.values.factorys[gcfactoryName] ~= nil then
		for gcfactory=1, #moGC_Factorys.values.factorys[gcfactoryName] do
			if moGC_Factorys.values.factorys[gcfactoryName][gcfactory] ~= nil then
				local gcfactoryGeneral = moGC_Factorys.values.factorys[gcfactoryName][gcfactory].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];
				
				if #moGC_Factorys.values.factorys[gcfactoryName] > 1 and gcfactory ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = gcfactorys.returnLineHelpIconClick
				isLineTable.helpTxt = "Click FactoryName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				local color = 1;				
				isLineTable.ownValues = {gcfactoryName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = gcfactoryGeneral.object.rootNode;				
				--isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;			
				local isNearObject = moModule:nearPlayerPosition(gcfactoryGeneral.object, 20, true);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = gcfactorys.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. gcfactoryGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = gcfactoryGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				--productivity
				if gcfactoryGeneral.productivityObject ~= nil and gcfactoryGeneral.productivityObject then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {gcfactoryName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 80;	--width prozent	
					color = Utils.getNoNil(moColors.prozent[gcfactoryGeneral.productivityColor], 1);
					isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = gcfactoryGeneral.productivityName;
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = gcfactoryGeneral.productivity.. "%";
					isLineTable.txt[2].txtPos = 2;
					if not gcfactoryGeneral.productivityActive then isLineTable.txt[2].txt = "OFF";end;
				end;
				--productivity
				--output
				local gcfactoryOutput = moGC_Factorys.values.factorys[gcfactoryName][gcfactory].output;
				if gcfactoryOutput ~= nil and #gcfactoryOutput > 0 then
					for output=1, #gcfactoryOutput do
						local outputTable = gcfactoryOutput[output];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {gcfactoryName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = outputTable.fillTypeName;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;						
						isLineTable.txt[2].txt = outputTable.fillLevel;
						isLineTable.txt[2].clickCallback = gcfactorys.returnClickFillLevelCapacityTotal;
						isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
						isLineTable.txt[2].txtPos = 2;
						if outputTable.palFull ~= nil then							
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];				
							isLineTable.ownValues = {gcfactoryName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = moLanguageXml:getTxt("pallets", nil, g_i18n:getText("category_pallets"));
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = tostring(outputTable.palFull);
							isLineTable.txt[2].txtPos = 2;
						end;
					end;
				end;
				--output
				--input
				local gcfactoryInput = moGC_Factorys.values.factorys[gcfactoryName][gcfactory].input;
				if gcfactoryInput ~= nil and #gcfactoryInput > 0 then
					if #gcfactoryInput > 0 then
						isLineTable.txt[1].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 0};
						isLineTable.txt[2].lineBorder = {6, 0.0005, false, true, false, false, moColors.intern["darkGray"], 2};
					end;
					for input=1, #gcfactoryInput do
						local inputTable = gcfactoryInput[input];
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];				
						isLineTable.ownValues = {gcfactoryName};
						isLineTable.txt = {};						
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[1].bold = moModule.values.txtBold;
						if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
							isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
							isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
							isLineTable.txt[1].clickCallback = gcfactorys.returnClickFillTypesTotal;							
						else
							isLineTable.txt[1].txt = inputTable.fillTypeName;
						end;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	
						--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;						
						isLineTable.txt[2].txt = tostring(inputTable.percentageCapacity).. "%";
						isLineTable.txt[2].txtPos = 2;
						if inputTable.fillTypeName:lower() == "geld" or inputTable.fillTypeName:lower() == "money" then
							isLineTable.txt[2].txt = tostring(inputTable.fillLevel).. moLanguageXml:getTxt("moneysymbol", nil, "€");
							isLineTable.txt[2].clickCallback = gcfactorys.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.percentageCapacity), true};	
						else
							isLineTable.txt[2].clickCallback = gcfactorys.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.fillLevel)};						
						end;
					end;
				end;
				--input
			end;
		end;
	end;
	gcfactorys[gcfactoryName] = {output=lineTable};
end;

function gcfactorys.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = gcfactorys[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = gcfactorys[args.ownValues[1]].output[args.line].txt[2].ownValues[2];
			local flipFillLevel = gcfactorys[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			--if string.len(capacity) > 0 then				
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
				local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");
				local prozent = ""
				if flipFillLevel ~= nil then prozent = "%";end;				
				moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
			--end;
		end;
	end;
end;

function gcfactorys.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = gcfactorys[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;

function gcfactorys.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(gcfactorys[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function gcfactorys.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local gcfactoryName = args.ownValues[1];
			if gcfactorys[gcfactoryName] ~= nil and gcfactorys[gcfactoryName].output ~= nil and gcfactorys[gcfactoryName].output[args.line] ~= nil then
				local nodeId = gcfactorys[gcfactoryName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId); --einige gc objecte geben 0 zurück !! grund !!				
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function gcfactorys.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.gcfactorys.isRunning = true;moModule.active.gcfactorys.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local gcfactoryName = args.ownValues[1];
			gcfactorys:load(gcfactoryName);
			return gcfactorys[gcfactoryName].output;
		end;		
	end;
end;

function gcfactorys.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--gcfactorys:load();	
end;

function gcfactorys:generateCmd(gcfactoryName)
	local _, errorTable = 0, {};
	function insertCmd(gcfactoryName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local gcfactoryNameTemp = tostring(gcfactoryName):lower();
		local languageName = moLanguageXml:getTxt(gcfactoryNameTemp, nil, gcfactoryName);
		newCmdTable.cmdTable[1] = {
			cmdName = "gcfactorys_".. tostring(gcfactoryName);
			displayName = moLanguageXml:getTxt("factorys", nil, "Factorys").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "GC Factorys";
			infoTxt = "Zeigt alle GC Factorys oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View GC Factorys or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;			
			typ = "output";
			action = gcfactorys.giveOutputTable; --a function
			ownValues = {gcfactoryName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate gcfactorys Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if gcfactoryName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "gcfactorys_".. gcfactoryName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(gcfactoryName);end;
	else
		--old
		--if moModule.gc.factorys ~= nil and #moModule.gc.factorys > 0 then
		--	for index=1, #moModule.gc.factorys do
		--		local gcfactoryName = moModule.gc.factorys[index].xmlName;
		--		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "gcfactorys_".. gcfactoryName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		--		if isAlreadyExits == nil then insertCmd(gcfactoryName);end;
		--	end;			
		--end;
		--old
		if moGC_Factorys.values ~= nil then			
			for gcfactoryName, _ in pairs (moGC_Factorys.values.factorys) do				
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "gcfactorys_".. gcfactoryName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(gcfactoryName, moModule:getObjectIds(moGC_Factorys.values.factorys[gcfactoryName], true));end;
			end;
		end;
	end;	
end;
